
// display.h

#include "back1.h"
#include "back2.h"
#include "logo.h"
#include "gauge.h"

#ifndef _DISPLAY_H_
#define _DISPLAY_H_

//--------------------------------------------------------------------------------------------------
// Compiler directive that allow using backgroung under painting
// To disable this feature comment it
//--------------------------------------------------------------------------------------------------
#define DRAW_OVER_BACKGROUND

//--------------------------------------------------------------------------------------------------
// Include font files
//--------------------------------------------------------------------------------------------------
#include "small_font.h"
#include "big_font.h"

//--------------------------------------------------------------------------------------------------
// Background variable
//--------------------------------------------------------------------------------------------------
#ifdef DRAW_OVER_BACKGROUND
static const char *Background;

typedef enum
{
  DRAW_OR = 0,
  DRAW_XOR = 1,
  DRAW_CLEAR = 2
} draw_type;
#endif // DRAW_OVER_BACKGROUND

//--------------------------------------------------------------------------------------------------
// Public function prototypes
//--------------------------------------------------------------------------------------------------
void LcdClear (void);
void LcdContrast (char contrast);
void LcdGoto (char x, char y);
void LcdImage (char x, char y, char xsize, char ysize, const char * dataPtr);
void LcdSendData (char data);
void LcdSendCommand (char command);

#ifdef DRAW_OVER_BACKGROUND
void LcdInit (const char * dataPtr);
void LcdSetBackground (const char * dataPtr);
void LcdChr (char ch, draw_type dt);
void LcdStr (char *dataPtr, draw_type dt);
void LcdCStr (const char * dataPtr, draw_type dt);
void LcdBigChr (char x, char y, char ch, draw_type dt);
void LcdBigStr (char x, char y, char *dataPtr, draw_type dt);
void LcdBigCStr (char x, char y, const char *dataPtr, draw_type dt);
void LcdVBargraph (char x, char ystart, char yend, char yposition, draw_type dt);
void LcdHBargraph (char y, char xstart, char xend, char xposition, draw_type dt);
void LcdLine (char xb, char yb, char xe, char ye, draw_type dt);

#else  // DRAW_OVER_BACKGROUND
void LcdInit (void);
void LcdChr (char ch);
void LcdStr (char *dataPtr);
void LcdCStr (const char * dataPtr);
void LcdBigChr (char x, char y, char ch);
void LcdBigStr (char x, char y, char *dataPtr);
void LcdBigCStr (char x, char y, const char *dataPtr);
void LcdVBargraph (char x, char ystart, char yend, char yposition);
void LcdHBargraph (char y, char xstart, char xend, char xposition);
void LcdLine (char xb, char yb, char xe, char ye);

#endif // DRAW_OVER_BACKGROUND

#endif // _DISPLAY_H_
