
// main.c (IMAGECRAFT ICCAVR 6.31 C-compiler)

#include <iom16v.h>
#include <macros.h>
#include <string.h>
#include <math.h>

typedef unsigned char byte;
typedef unsigned int word;
#define bit0	0x01
#define bit1	0x02
#define bit2	0x04
#define bit3	0x08
#define bit4	0x10
#define bit5	0x20
#define bit6	0x40
#define bit7	0x80
#define bit8	0x0100
#define bit9	0x0200
#define bit10	0x0400
#define bit11	0x0800
#define bit12	0x1000
#define bit13	0x2000
#define bit14	0x4000
#define bit15	0x8000

#define	SPM_oPort	PORTB
#define	SPM_Dir		DDRB
#define	SPM_CLK		bit7
#define	SPM_MOSI	bit5
#define	SPM_MISO	bit6
#define	SPM_SS		bit4

#define LCD_DC_PORT PORTA
#define LCD_DC_DIR0 DDRA
#define LCD_DC_DIR1 DDRA
#define LCD_DC_PIN	bit7		// PA7 - DC
#define LCD_RST_PORT PORTA
#define LCD_RST_DIR0 DDRA
#define LCD_RST_DIR1 DDRA
#define LCD_RST_PIN	bit4		// PA4 - RES

#define M8C_DisableGInt		CLI()			// DISABLE all interrupts
#define M8C_EnableGInt		SEI()			// re-enable interrupts

#define Neg_Clock		0x02
#define Trailing_Edge	0x04
#define SPIM_SPIM_MODE_0	0      // MODE 0 - Leading edge latches data - pos clock
#define SPIM_SPIM_MSB_FIRST		0x00      // MSB bit transmitted/received first
#define SPIM_SPIM_LSB_FIRST		0x80      // LSB bit transmitted/received first
#define SPIM_SPIM_TX_BUFFER_EMPTY	0x80
#define	bSPIM_ReadStatus() SPSR

void SPIM_SendTxData(byte b) { SPDR = b; }

void SPIM_Start(byte m) { //  MASTER
	SPM_Dir |= (SPM_CLK|SPM_MOSI|SPM_SS);  // Set SCK, MOSI & SS as outputs
	SPM_oPort &= ~(SPM_CLK|SPM_MOSI|SPM_SS);  // clear bits MOSI, & SCK		!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! OK
	SPCR = (1<<SPE) | (1<<MSTR) // 1000kHz
//		| (1<<SPR0); // 250kHz
//		| (1<<SPR1); // 62.5kHz
		| (1<<SPR1) | (1<<SPR0); // 31.25kHz -   
	if (m & Neg_Clock) SPCR |= (1<<CPOL);			// mode=1,3
	if (m & Trailing_Edge) SPCR |= (1<<CPHA);		// mode=2,4
	if (m & SPIM_SPIM_LSB_FIRST) SPCR |= (1<<DORD);
}

#include "pcd8544.h"

void main(void) {
int i,i1,i2;
	M8C_DisableGInt;

	PORTA = 0x00;
	DDRA  = 0x00;
	PORTB = 0x00;
	DDRB  = 0x00;
	PORTC = 0x00; //m103 output only
	DDRC  = 0x00;
	PORTD = 0x00;
	DDRD  = 0x00;

	MCUCR = 0x00;
	GICR  = 0x00;

	LCD_DC_DIR1	 |=	LCD_DC_PIN;
	LCD_RST_DIR1 |=	LCD_RST_PIN;

	LCD_DC_PORT &= ~LCD_DC_PIN;
	LCD_RST_PORT &= ~LCD_RST_PIN;

	M8C_EnableGInt;

	//-------------------------------

	LcdInit(back1);
	// first screen
	LcdGoto(5,1);
	LcdCStr("CypressMicro",DRAW_OR);
	LcdGoto(5,2);
	LcdCStr("PSoC and LCD",DRAW_OR);
	LcdGoto(8,3);
	LcdCStr("interfacing",DRAW_OR);
	LcdGoto(20,4);
	LcdCStr("example",DRAW_OR);
	for (i=-32000;i<32000;i++); // delay
	// Fonts Demo Screen
	LcdClear();
	LcdBigCStr(5,1,"Big Font",DRAW_OR);
	LcdGoto(5,4);
	LcdCStr("Small Font",DRAW_OR);
	for (i=-32000;i<32000;i++); // delay
	// XOR draw Over Background example screen
	LcdSetBackground(back2);
	LcdClear();
	LcdBigCStr(5,1,"XOR DRAW",DRAW_XOR);
	LcdGoto(30,3);
	LcdCStr("OVER",DRAW_XOR);
	LcdGoto(12,4);
	LcdCStr("BACKGROUND",DRAW_XOR);
	for (i=-32000;i<32000;i++); //delay
	// Horizontal bargraphs example screen
	LcdSetBackground(back1);
	LcdClear();
	LcdGoto(4,1);
	LcdChr('V',DRAW_OR);
	LcdGoto(4,3);
	LcdChr('I',DRAW_OR);
	for (i=0;i<16;i++) {
	    LcdHBargraph(1,15,79,i,DRAW_OR);
	    for (i1=0;i1<48;i1++) {
			LcdHBargraph(3,15,79,i1,DRAW_OR);
			for (i2=0;i2<74;i2++);
		}
	};
	// Vertical bargraphs example screen
	LcdClear();
	LcdGoto(10,1);
	LcdChr('V',DRAW_OR);
	LcdGoto(30,1);
	LcdChr('I',DRAW_OR);
	for (i=0;i<10;i++) {
		LcdVBargraph(10,2,4,i,DRAW_OR);
		for (i1=0;i1<20;i1++) {
			LcdVBargraph(30,2,4,i1,DRAW_OR);
			for (i2=0;i2<740;i2++);
		}
	};
  	for (i=-32000;i<32000;i++); // delay
	// Bitmap draw example screen
	LcdClear();
	LcdImage(11,1,62,4,logo);
	for (i=-32000;i<32000;i++); // delay
	// Line draw example screen
	LcdSetBackground(gauge);
	LcdClear();
	while (1) {
		LcdLine (6,15,42,45,DRAW_OR);
		for (i=-3200;i<3200;i++); // delay
		LcdLine (6,15,42,45,DRAW_CLEAR);
		LcdLine (7,14,42,45,DRAW_OR);
		for (i=-3200;i<3200;i++); // delay
		LcdLine (7,14,42,45,DRAW_CLEAR);
		LcdLine (9,14,42,45,DRAW_OR);
		for (i=-3200;i<3200;i++); // delay
		LcdLine (9,14,42,45,DRAW_CLEAR);
		LcdLine (10,12,42,45,DRAW_OR);
		for (i=-3200;i<3200;i++); // delay
		LcdLine (10,12,42,45,DRAW_CLEAR);
		LcdLine (26,6,42,45,DRAW_OR);
		for (i=-3200;i<3200;i++); // delay
		LcdLine (26,6,42,45,DRAW_CLEAR);
		LcdLine (43,4,42,45,DRAW_OR);
		for (i=-3200;i<3200;i++); // delay
		LcdLine (43,4,42,45,DRAW_CLEAR);
	}
}
